/* 
 * File:   msp3520.h
 * Created on 2022/05/15, 14:05
 */

//#ifndef MSP3520_H
#define	MSP3520_H

#define SCK LATBbits.LATB4
#define MISO PORTBbits.RB5
#define MOSI LATCbits.LATC7
#define LCDCS LATCbits.LATC6
#define LCDRS LATBbits.LATB1

#define SPI8(d) hardware_spi8(d)
#define CLS() fill_ili9488(0)
#define LOCATE(x,y) locate_ili9488(x,y)
#define PUTS(s) puts_ili9488(s)

#define C_BROWN color_code[0]
#define C_RED color_code[1]
#define C_ORANGE color_code[2]
#define C_YELLOW color_code[3]
#define C_GREEN color_code[4]
#define C_BLUE color_code[5]
#define C_PURPLE color_code[6]
#define C_GRAY color_code[7]
#define C_WHITE color_code[8]
#define C_BLACK color_code[9]

#define XSIZE 480
#define YSIZE 320

//struct xy_coord {
//  long int x, y;
//};

extern unsigned int lcdx, lcdy;    // XY position, graphic/character current point
extern unsigned short int fcolor, bcolor;  // character color
extern unsigned short int color_code[10];

void wait_us( int t );
void wait_ms( int t );
unsigned char software_spi8( unsigned char d );
void iniz_spi1( void );
unsigned char hardware_spi8( unsigned char d );
void iniz_ili9488( void );
void display_on_ili9488( void );
void fill_ili9488( unsigned short int c );
void vertical_line_ili9488( unsigned int x, unsigned int y, unsigned int l, unsigned short int c );
void horizontal_line_ili9488( unsigned int x, unsigned int y, unsigned int l, unsigned short int c );
void pset_ili9488( unsigned int x, unsigned int y, unsigned short int c );
void locate_ili9488( unsigned int x, unsigned int y );
void putchar_ili9488( char c );
void puts_ili9488( char *s );
void line_ili9488( unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short int c );
void rectangle_ili9488( unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short int c );
void put_symbol_ili9488( char c, int mag );
void puts_symbol_ili9488( int mag, char *s );
